/*
    Fin - a simple personal accounts manager
    Copyright (C) 2012  Bob Mottram <bob@sluggish.dyndns.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GLOBALS_H
#define GLOBALS_H

#define VERSION_NUMBER                 1.40

#define MAX_ARGS                       32
#define FIELD_WIDTH                    256

#define DECIMAL_PLACES                 8
#define DECIMAL_PLACES_QUANTITY        8

#define LEADING_SPACES                 6
#define TRAILING_ZEROS                 2

#define MAX_ROW_LENGTH                 80

#define DEFAULT_INFLATION_RATE         2.0
#define DEFAULT_USURY_RATE             18.0

#define DISTRIBUTION_SIZE              100
#define DEFAULT_DISTRIBUTION_INCREMENT 5

/* terminal colours */
#define USE_COLOURS

#define NORMAL  "\x1B[0m"
#define RED     "\x1B[31m"
#define GREEN   "\x1B[32m"
#define YELLOW  "\x1B[33m"
#define BLUE    "\x1B[34m"
#define MAGENTA "\x1B[35m"
#define CYAN    "\x1B[36m"
#define WHITE   "\x1B[37m"

#define COLOUR_POSITIVE BLUE
#define COLOUR_NEGATIVE CYAN

#define COLOUR_BEFORE GREEN
#define COLOUR_AFTER  YELLOW
#define COLOUR_DELETE RED

/* maximum string length */
#define STRING_BLOCK  256

#define ADJUSTMENT_TYPE_BEFORE 'B'
#define ADJUSTMENT_TYPE_AFTER  'A'
#define ADJUSTMENT_TYPE_DELETE 'D'

#define YEAR_BASELINE 1900

#endif
