/*
    Fin - a simple personal accounts manager
    Copyright (C) 2012  Bob Mottram <bob@sluggish.dyndns.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef INTERNATIONAL_H
#define INTERNATIONAL_H

#include "validation.h"

enum LANGUAGE {
  ENGLISH_UK=0,
  ENGLISH_US,
  FRENCH,
  GERMAN,
  ITALIAN,
  SPANISH,
  GREEK,
  RUSSIAN,
  POLISH,
  DUTCH,
  CHINESE,
  LANGUAGES
};

enum IDENTIFIER {
  SUPPLIER=0,
  SUPPLIER_ABBREV,

  LOCK,
  LOCK_ABBREV,

  EDIT,
  EDIT_ABBREV,

  VERSION,
  VERSION_ABBREV,

  HELP,
  HELP_ABBREV,

  LANGUAGE,
  LANGUAGE_ABBREV,

  TO,
  TO_ABBREV,

  DATE_FORMAT,
  DATE_FORMAT_ABBREV,

  TRANSFER,
  TRANSFER_ABBREV,

  PUSH,
  PUSH_ABBREV,

  PULL,
  PULL_ABBREV,

  AT,
  AT_ABBREV,

  SEARCH,
  SEARCH_ABBREV,

  SPEAK,
  SPEAK_ABBREV,

  ADJUSTMENTS,
  ADJUSTMENTS_ABBREV,

  TIME,
  TIME_ABBREV,

  VOLUME,
  VOLUME_ABBREV,

  MAXIMUM,
  MAXIMUM_ABBREV,

  DISTRIBUTION,
  DISTRIBUTION_ABBREV,

  SAVINGS_INTEREST_RATE,
  SAVINGS_INTEREST_RATE_ABBREV,

  LOANS_INTEREST_RATE,
  LOANS_INTEREST_RATE_ABBREV,

  INFLATION_RATE,
  INFLATION_RATE_ABBREV,

  SUMMARY_TRANSACTIONS,
  SUMMARY_TRANSACTIONS_ABBREV,

  SUMMARY_RECORDS,
  SUMMARY_RECORDS_ABBREV,

  VAT_RATE,
  VAT_RATE_ABBREV,

  CUSTOMER,
  CUSTOMER_ABBREV,

  LATITUDE,
  LATITUDE_ABBREV,

  LONGITUDE,
  LONGITUDE_ABBREV,

  ALTITUDE,
  ALTITUDE_ABBREV,

  PROGRESS,
  PROGRESS_ABBREV,

  TRACKING_NUMBER,
  TRACKING_NUMBER_ABBREV,

  CURRENCY,
  CURRENCY_ABBREV,

  STATUS,
  STATUS_ABBREV,

  QUANTITY,
  QUANTITY_ABBREV,

  NUMBER,
  NUMBER_ABBREV,

  ACCOUNT,
  ACCOUNT_ABBREV,

  DESCRIPTION,
  DESCRIPTION_ABBREV,

  INVOICE_NUMBER,
  INVOICE_NUMBER_ABBREV,

  PART_NUMBER,
  PART_NUMBER_ABBREV,

  SALE_NUMBER,
  SALE_NUMBER_ABBREV,

  PURCHASE_NUMBER,
  PURCHASE_NUMBER_ABBREV,

  WORKS_NUMBER,
  WORKS_NUMBER_ABBREV,

  SERIAL_NUMBER,
  SERIAL_NUMBER_ABBREV,

  JOB_NUMBER,
  JOB_NUMBER_ABBREV,

  DATE,
  DATE_ABBREV,


  COMMAND_SPEND,
  COMMAND_OUTGOING,
  COMMAND_PAID,
  COMMAND_BUY,
  COMMAND_BOUGHT,
  COMMAND_PURCHASE,
  COMMAND_PURCHASED,
  COMMAND_SPENT,
  COMMAND_SELL,
  COMMAND_SOLD,
  COMMAND_INCOME,
  COMMAND_EARN,
  COMMAND_EARNED,
  COMMAND_EARNINGS,
  COMMAND_RECEIVE,
  COMMAND_RECEIVED,

  COMMAND_IMPORT,

  COMMAND_EXPORT,

  COMMAND_REPORT,

  COMMAND_ACCOUNT,

  COMMAND_LIST,
  COMMAND_LS,

  COMMAND_CALENDAR,

  COMMAND_TESTS,

  COMMAND_RECUR,

  PERIOD_DAILY,
  PERIOD_2DAILY,
  PERIOD_3DAILY,
  PERIOD_4DAILY,
  PERIOD_5DAILY,
  PERIOD_6DAILY,
  PERIOD_WEEKLY,
  PERIOD_BIWEEKLY,
  PERIOD_2WEEKLY,
  PERIOD_MONTHLY,
  PERIOD_2MONTHLY,
  PERIOD_3MONTHLY,
  PERIOD_6MONTHLY,
  PERIOD_YEARLY,
  PERIOD_ANNUAL,
  PERIOD_ANNUALLY,
  PERIOD_2YEARLY,

  SETTINGS_FILENAME,
  SETTINGS_SERVER,
  SETTINGS_DATE_FORMAT,
  SETTINGS_VAT_RATE,
  SETTINGS_ACCOUNT,
  SETTINGS_CURRENCY,
  SETTINGS_DEFAULT_CURRENT_ACCOUNT,
  SETTINGS_DEFAULT_SAVINGS_ACCOUNT,
  SETTINGS_DEFAULT_CURRENCY,
  SETTINGS_DEFAULT_VAT_RATE,
  SETTINGS_DEFAULT_DATE_FORMAT,

  TRANSACTION_CANCEL,
  TRANSACTION_REMOVE,
  TRANSACTION_REVERSE,
  TRANSACTION_DELETE,
  TRANSACTION_KILL,
  TRANSACTION_UNDO,

  MESSAGE_SPENT,
  MESSAGE_RECEIVED,
  MESSAGE_NOT_VALID_AMOUNT,
  TITLE_RECENT_TRANSACTIONS,
  TITLE_RECENT_TRANSACTIONS_MONTHLY,
  TITLE_ACCOUNT_SUMMARY,
  TITLE_MONTHLY_SUMMARY,
  TITLE_YEARLY_SUMMARY,
  HEADER_MONTHLY_SUMMARY,
  HEADER_YEARLY_SUMMARY,
  TITLE_SEARCH_RESULTS,
  SUMMARY_BALANCE,
  TOTALS,
  WARNING_NO_SERVER,

  COMMAND_MONTH,
  COMMAND_MONTH_ABBREV,

  COMMAND_YEAR,
  COMMAND_YEAR_ABBREV,

  COMMAND_END_YEAR,
  COMMAND_END_YEAR_ABBREV,

  MONTH_JAN,
  MONTH_JAN_ABBREV,

  MONTH_FEB,
  MONTH_FEB_ABBREV,

  MONTH_MAR,
  MONTH_MAR_ABBREV,

  MONTH_APR,
  MONTH_APR_ABBREV,

  MONTH_MAY,
  MONTH_MAY_ABBREV,

  MONTH_JUN,
  MONTH_JUN_ABBREV,

  MONTH_JUL,
  MONTH_JUL_ABBREV,

  MONTH_AUG,
  MONTH_AUG_ABBREV,

  MONTH_SEP,
  MONTH_SEP_ABBREV,

  MONTH_OCT,
  MONTH_OCT_ABBREV,

  MONTH_NOV,
  MONTH_NOV_ABBREV,

  MONTH_DEC,
  MONTH_DEC_ABBREV,

  ACCOUNT_CHANGED,
  CURRENCY_CHANGED,
  WARNING_CURRENCY,
  CANCEL_TRANSACTION,
  CANCEL_TRANSACTION_STATUS,
  DATE_FORMAT_CHANGED,
  EXPORT_COMPLETED,

  COMMAND_SEPARATOR,
  TAB,
  EXPORT_MONTHLY_HEADER,
  EXPORT_YEARLY_HEADER,
  TRANSFER_TO,
  TRANSFER_FROM,
  TRANSFER_COMPLETE,
  SETTINGS_LANGUAGE,
  LANGUAGE_CHANGED,
  KML,
  SHOW_VERSION,
  TRANSACTIONS_IMPORTED,

  MONEY_IN,
  MONEY_OUT,
  CREDIT,
  DEBIT,
  AMOUNT,
  MEMO,
  NOTES,
  CATEGORY,
  SUBCATEGORY,
  IMPORT_DESCRIPTION,
  IMPORT_NAME,
  IMPORT_TYPE,
  IMPORT_IN,
  IMPORT_OUT,
  BALANCE,
  TITLE_MONTHLY_VOLUMES,
  TITLE_YEARLY_VOLUMES,
  TITLE_SPENDING_ON_ACCOUNT_SEARCH,
  BALANCE_FOR_ACCOUNT,
  RECORD_UNDONE,
  RECORD_EDITED,
  EXPORT_IMAGE,

  NO_TRANSACTIONS,
  TITLE_DISTRIBUTION,
  TITLE_DISTRIBUTION_YEARS,
  TITLE_ACCOUNT,
  TIME_AM,
  TIME_PM,
  FREQUENCY,
  SPENDING,
  CURRENCY_CONVERSION,
  CURRENCY_POUNDS,
  CURRENCY_DOLLARS,
  CURRENCY_EUROS,
  CURRENCY_RUBLES,
  CURRENCY_YUAN,
  CURRENCY_YEN,
  TITLE,
  PIECHART,
  PERCENT,
  CATEGORY_OTHER,
  WARNING_NO_INCOME,
  RECENT_EDITS,
  TITLE_ADJUSTMENTS,
  COMMAND_STYLE,
  COMMAND_STYLE_ABBREV,
  STYLE_EMACS,
  STYLE_ORG,
  STYLE_ORGMODE,

  NARRATOR_BALANCE,
  NARRATOR_BALANCE_NEGATIVE,
  NARRATOR_AVERAGE_INCOME,
  NARRATOR_AVERAGE_SPENDING,
  NARRATOR_MONTHS_TO_BROKE,
  NARRATOR_YEARS_TO_BROKE,
  NARRATOR_SUSTAINABLE,
  NARRATOR_MONTHS_TO_REPAID,
  NARRATOR_YEARS_TO_REPAID,
  NARRATOR_DELINQUENT,
  NARRATOR_SPENT_MORE,
  NARRATOR_SPENT_LESS,
  NARRATOR_SPENT_SAME,

  IDENTIFIERS
};

char * get_text_from_identifier(int identifier);
void set_language(int index);
void set_language_from_string(char * language);

#endif
